﻿using System;
using System.Linq;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;

namespace DefaultCombat.Routines
{
    // Darkness Assassin v1.0 - Cystacae/Edited by Neo93
    // Known Bugs:  Can't get behind on pull, Also same as Madness Assassin that randomly Force Lightning may interfere.  I only say may because I have yet to see it but Madness code is relatively the same.
    public static class CommandoGunnery
    {
		public static bool Burn = false;
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Trooper, AdvancedClass.Commando, SkillTreeId.CommandoGunnery)]
        public static Composite CommandoGunneryPull()
        {
            return CommandoGunneryCombat();
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Trooper, AdvancedClass.Commando, SkillTreeId.CommandoGunnery)]
        public static Composite CommandoGunneryCombat()
        {
            return new PrioritySelector(
                Spell.WaitForCast(),
                Movement.StopInRange(2.8f),

                //***Generel***
                Spell.Cast("Tenacity", ret => BuddyTor.Me.IsStunned),
                Spell.Cast("Adrenaline Rush", ret => BuddyTor.Me, ret => BuddyTor.Me.HealthPercent <= 30),//-30 Health

                //**Defensive**
                Spell.Cast("Reactive Shield", castWhen => BuddyTor.Me.InCombat && !BuddyTor.Me.HasBuff("Reactive Shield")),

                //**CC**
                Spell.Cast("Concussive Round", on => Helpers.ccTarget(), castWhen => Helpers.Targets.Count() >= 4),

                //*Interrupts*
                Spell.Cast("Disabling Shot", ret => BuddyTor.Me.CurrentTarget.IsCasting),


                //Rotation
                Spell.Cast("Plasma Grenade", castWhen => Helpers.Targets.Count() >= 2 && BuddyTor.Me.ResourceStat >= 10),//+30 Energy
                Spell.Cast("Grav Round", castWhen => BuddyTor.Me.ResourceStat <= 49),//+19 Energy
                Spell.Cast("Grav Round", castWhen => BuddyTor.Me.ResourceStat <= 68),//+19 Energy
                Spell.Cast("Demolition Round"),//+16 Energy
                Spell.Cast("Electro Net"),//+8 Energy
                Spell.Cast("Reserve Powercell"), //-50 Energy
                Spell.Cast("High Impact Bolt", ret => BuddyTor.Me.HasBuff("Charged Barrel")),//+16 Energy
                Spell.Cast("Full Auto", ret => BuddyTor.Me.HasBuff("Curtain of Fire")),//+16 Energy
                Spell.Cast("Sticky Grenade", castWhen => Helpers.Targets.Count() >= 3 && BuddyTor.Me.ResourceStat >= 10),//+16 Energy
                Spell.Cast("Pulse Cannon", castWhen => BuddyTor.Me.ResourceStat <= 63 && Helpers.Targets.Count(t => t.Distance <= 1) >= 3),//+25 Energy
                Spell.Cast("Hammer Shot"),//+0 Energy

                //Movement
                Movement.MoveTo(ret => BuddyTor.Me.CurrentTarget.Position, 2.8f)
                );
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Trooper, AdvancedClass.Commando, SkillTreeId.CommandoGunnery)]
        public static Composite CommandoGunneryOutOfCombat()
        {
            return new PrioritySelector(
                Spell.BuffSelf("Plasma Cell")//Weapon Buff
                );
        }
    }
}
