﻿using System;
using System.Linq;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;

namespace DefaultCombat.Routines
{
    // Darkness Assassin v1.0 - Cystacae/Edited by Neo93
    // Known Bugs:  Can't get behind on pull, Also same as Madness Assassin that randomly Force Lightning may interfere.  I only say may because I have yet to see it but Madness code is relatively the same.
    public static class GunslingerSharpshooter
    {
		public static bool Burn = false;
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSharpshooter)]
        public static Composite GunslingerSharpshooterPull()
        {
            return GunslingerSharpshooterCombat();
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSharpshooter)]
        public static Composite GunslingerSharpshooterCombat()
        {
            return new PrioritySelector(
                Spell.WaitForCast(),
                Movement.StopInRange(2.8f),

                //***Generel***
                Spell.Cast("Escape", ret => BuddyTor.Me.IsStunned),
                

                //**Defensive**
                Spell.Cast(" Scrambling Field", ret => BuddyTor.Me, ret => BuddyTor.Me.HealthPercent <= 50),//-50 Health
                Spell.Cast(" Defense Screen", ret => BuddyTor.Me, ret => BuddyTor.Me.HealthPercent <= 30),//-30 Health

                //**CC**
                //Spell.Cast("Concussive Round", on => Helpers.ccTarget(), castWhen => Helpers.Targets.Count() >= 4),

                //*Interrupts*
                Spell.Cast("Distraction", ret => BuddyTor.Me.CurrentTarget.IsCasting),


                //Rotation
                Spell.Cast("Hightail It", ret => !BuddyTor.Me.HasBuff("Cover")),
                Spell.Cast("Crouch", ret => !BuddyTor.Me.HasBuff("Cover")),
                Spell.Cast("Flourish Shot"),
                Spell.Cast("Speed Shot"),
                Spell.Cast("Trickshot"),
                Spell.Cast("Charged Burst"),
                Spell.Cast("Trickshot"),
                Spell.Cast("Quickdraw"),
                Spell.Cast("Trickshot"),
                Spell.Cast("Aimed Shot "),
                Spell.Cast("Trickshot"),
                Spell.Cast("Vital Shot"),
                Spell.Cast("XS Freighter Flyby"),
                Spell.Cast("Flurry of Bolts"),
                Spell.Cast("Quick Shot "),

                //Movement
                Movement.MoveTo(ret => BuddyTor.Me.CurrentTarget.Position, 2.8f)
                );
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSharpshooter)]
        public static Composite GunslingerSharpshooterOutOfCombat()
        {
            return new PrioritySelector(
                Spell.BuffSelf("Lucky Shots")//Weapon Buff
                );
        }
    }
}
