﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using System.Diagnostics;

namespace DefaultCombat.Routines.Basic
{
    public class AgentBasic
    {
        [Class(CharacterClass.Agent)]
        [Behavior(BehaviorType.Combat)]
        public static Composite AgentCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.SniperMarksmanshipCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Class(CharacterClass.Agent)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite AgentOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }

        [Class(CharacterClass.Agent)]
        [Behavior(BehaviorType.Pull)]
        public static Composite AgentPull()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.SniperMarksmanshipCombat(); }), Spell.Cast("blah", ret => false));
        }
    }
}
