﻿using System;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using System.Linq;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;

namespace DefaultCombat.Routines.Basic
{
    public class Knight
    {
        [Class(CharacterClass.Knight)]
        [Behavior(BehaviorType.Combat)]
        public static Composite KnightCombat()
        {
            return new Sequence (new Action(ret => {MercHelpers.WatchmanCombat();}),
                Spell.Cast("blah", ret => false));
        }

        [Class(CharacterClass.Knight)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite KnightOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }

        [Class(CharacterClass.Knight)]
        [Behavior(BehaviorType.Pull)]
        public static Composite KnightPull()
        {
            return KnightCombat();
        }
    }
}