﻿using System;
using System.Linq;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;

namespace DefaultCombat.Routines
{
    //Neo93
    public static class MarauderAnnihilation
    {
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderAnnihilation)]
        public static Composite MarauderAnnihilationPull()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.MarauderAnnihilationCombat(); }),
                Spell.Cast("Channel Hatred", ret => false)
                );
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderAnnihilation)]
        public static Composite MarauderAnnihilationCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.MarauderAnnihilationCombat(); }),
                Spell.Cast("Channel Hatred", ret => false)
                );
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderAnnihilation)]
        public static Composite MarauderAnnihilationOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }),
                Spell.Cast("Channel Hatred", ret => false)
            );
        }
    }
}
