﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Buddy.Swtor.Objects;
using Buddy.Common.Math;
using System;
using Buddy.Common;
using Action = Buddy.BehaviorTree.Action;

using System.Collections.Generic;
using System.Diagnostics;
using System.ComponentModel;

//using DefaultCombat.MercHelpers;

namespace DefaultCombat.Routines
{
    public static class MercenaryBodyguard
    {

        //private static MercHelpers mh;

        [Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryBodyguard)]
        [Behavior(BehaviorType.Pull)]
        public static Composite MercenaryBodyguardPull()
        {
            return new Sequence(
                MercenaryBodyguardCombat(),
                Spell.Cast("blah", ret => false)
            );
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryBodyguard)]
        public static Composite MercenaryBodyguardCombat()
        {
            return new Sequence(
                new Action(ret => {
                    MercHelpers.BGCombat();
              })
          , new PrioritySelector(Spell.Cast("Recharge and Reload",ret=>false)));
        }


        [Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryBodyguard)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite MercenaryBodyguardOutOfCombat()
        {
            return new Sequence(
                new Action(ret => { MercHelpers.OOC(); }),
                new PrioritySelector(
                    Spell.Cast("Recharge and Reload",ret=>false) // No PrioritySelector, No Workie, so this meets that requirement.
                    )
                );
        }


    }
}
