﻿using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
//using System;
using System.Linq;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines.Basic
{
    public class CommandoCombatMedic
    {
        [Class(CharacterClass.Trooper, AdvancedClass.Commando, SkillTreeId.CommandoCombatMedic)]
        [Behavior(BehaviorType.Combat)]
        public static Composite TrooperCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => {MercHelpers.CombatMedicCombat();}));
        }

        [Class(CharacterClass.Trooper, AdvancedClass.Commando, SkillTreeId.CommandoCombatMedic)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite TrooperOutOfCombat()
        {
            return new Sequence(
                new Buddy.BehaviorTree.Action(ret=>{MercHelpers.OOC();}),
                Spell.Cast("Recharge and Reload", ret => false)
           );
        }

        [Class(CharacterClass.Trooper, AdvancedClass.Commando, SkillTreeId.CommandoCombatMedic)]
        [Behavior(BehaviorType.Pull)]
        public static Composite TrooperPull()
        {
            return new Sequence(
                    new Buddy.BehaviorTree.Action(ret => {MercHelpers.CombatMedicCombat();}),
                    Spell.Cast("Recharge and Reload", ret => false)
                );
        }
    }
}