﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    public static class OperativeConcealment
    {
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeConcealment)]
        public static Composite OperativeConcealmentPull()
        {
            return new Sequence(new Action(ret => { MercHelpers.ConcealmentCombat(); }), Spell.Cast("blah", ret => false));
        }
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeConcealment)]
        public static Composite OperativeConcealmentCombat()
        {
            return new Sequence(new Action(ret => { MercHelpers.ConcealmentCombat(); }), Spell.Cast("blah", ret => false));
        }
        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeConcealment)]
        public static Composite OperativeConcealmentOutOfCombat()
        {
            return new Sequence(new Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }
    }
}