﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines.Basic
{
    public class Consular
    {
        [Class(CharacterClass.Consular)]
        [Behavior(BehaviorType.Combat)]
        public static Composite ConsularCombat()
        {
            return new PrioritySelector(
                new Action(ret => {MercHelpers.SeerCombat();}),
                Spell.Cast("blah", ret => false)
                );
        }

        [Class(CharacterClass.Consular)]
        [Behavior(BehaviorType.Pull)]
        public static Composite ConsularPull()
        {
            return new PrioritySelector(
                new Action(ret => {MercHelpers.SeerCombat();}),
                Spell.Cast("blah", ret => false)
                );
        }

        [Class(CharacterClass.Consular)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite ConsularOOC()
        {
            return new PrioritySelector(
                new Action(ret => { if (BuddyTor.Me.HealthPercent < 80f || BuddyTor.Me.ForcePercent < 80f)
                {MercHelpers.WaitForHeals(false, "Meditation", true, .8f * BuddyTor.Me.ForceMax);return RunStatus.Success;} else return RunStatus.Failure; }),
                Spell.Cast("Force Valor", ch => BuddyTor.Me, ret => !BuddyTor.Me.HasBuff("Force Valor")),
                //Spell.Cast("Meditation", ch => BuddyTor.Me, ret => BuddyTor.Me.HealthPercent < 80f || BuddyTor.Me.ForcePercent < 80f),
                //new Action(ret => {MercHelpers.OOC();}),
                Spell.Cast("blah", ret => false)
                );
        }

    }
}