﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using Buddy.Swtor.Objects;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    //Neo93
    public static class SorcererCorruption
    {
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererCorruption)]
        public static Composite SorcererCorruptionPull()
        {
            return SorcererCorruptionCombat();
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererCorruption)]
        public static Composite SorcererCorruptionCombat()
        {
            //return MercHelpers.CorruptionCombatPvP();
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.CorruptionCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererCorruption)]
        public static Composite SorcererCorruptionOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }

    }
}