﻿using System;
using System.Linq;

using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;


namespace DefaultCombat.Routines
{
    public static class GuardianDefense
    {
        [Behavior(BehaviorType.Pull)]
        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianDefense)]
        [Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.None)]
        public static Composite GuardianDefensePull()
        {
            return GuardianDefenseCombat();
        }

        [Behavior(BehaviorType.Combat)]
        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianDefense)]
        [Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.None)]
        public static Composite GuardianDefenseCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.DefenseCombat(); }), Spell.Cast("blah", ret => false));
        }

        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianDefense)]
        [Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.None)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite GuardianDefenseOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }
    }
}
