﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    public static class ScoundrelDirtyFighting
    {
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.ScoundrelDirtyFighting)]
        public static Composite ScoundrelDirtyFightingPull()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.DirtyFightingCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.ScoundrelDirtyFighting)]
        public static Composite ScoundrelDirtyFightingCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.DirtyFightingCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.ScoundrelDirtyFighting)]
        public static Composite ScoundrelDirtyFightingOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }

    }
}