﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Buddy.Swtor.Objects;
using Buddy.Common.Math;
using System;
using Buddy.Common;

using Action = Buddy.BehaviorTree.Action;

using System.Collections.Generic;
using System.Diagnostics;
using System.ComponentModel;

namespace DefaultCombat.Routines
{
    public static class MercenaryFirebug
    {
        [Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryFirebug)]
        [Behavior(BehaviorType.Pull)]
        public static Composite MercenaryFirebugPull()
        {
            return new Sequence(
                new Action(ret => { GC.Collect(); GC.GetTotalMemory(true); 
                System.Threading.Thread.Sleep(400);}),
                MercenaryFirebugCombat()
            );
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryFirebug)]
        public static Composite MercenaryFirebugCombat()
        {
            return new Sequence(
                new Action(ret => {
                    MercHelpers.FirebugCombat();
              })
          , new PrioritySelector(Spell.Cast("Recharge and Reload",ret=>false)));
        }


        [Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryFirebug)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite MercenaryFirebugOutOfCombat()
        {
            return new Sequence(
                new Action(ret => { MercHelpers.OOC(); }),
                new PrioritySelector(
                    Spell.Cast("Recharge and Reload",ret=>false) // No PrioritySelector, No Workie, so this meets that requirement.
                    )
                );
        }

    }
}
