﻿using System;
using System.Linq;

using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;


namespace DefaultCombat.Routines
{
    //Neo93 07.05.2012
    public static class JuggernautImmortal
    {
        [Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautImmortal)]
        [Behavior(BehaviorType.Pull)]
        public static Composite JuggernautImmortalPull()
        {
            return new Sequence(
            new Action(ret => { MercHelpers.JuggernautCombat(); }),
            Spell.Cast("blah", ret => false));

        }

        [Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautImmortal)]
        [Behavior(BehaviorType.Combat)]
        public static Composite JuggernautImmortalCombat()
        {
            return new Sequence(
                new Action(ret => { MercHelpers.JuggernautCombat(); }),
                Spell.Cast("blah", ret => false));

        }

        [Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautImmortal)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite JuggernautImmortalOutOfCombat()
        {
            return new Sequence(
                new Action(ret=>{MercHelpers.OOC();}),
                Spell.Cast("blah", ret => false)
             );
        }
    }
}
