﻿using System;
using System.Linq;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;

namespace DefaultCombat.Routines
{

    public static class ShadowKinetic
    {
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowCombat)]
        public static Composite ShadowKineticPull()
        {
            return new Sequence (Spell.Cast("Stealth", ch => BuddyTor.Me, ret => true),
                new Action(ret => {MercHelpers.ConsularKineticCombat();}),
                Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowCombat)]
        public static Composite ShadowKineticCombat()
        {
            return new Sequence(
                new Action(ret => { MercHelpers.ConsularKineticCombat(); }),
                Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowCombat)]
        public static Composite ShadowKineticOutOfCombat()
        {
            return new Sequence(
                new Action(ret => { MercHelpers.OOC(); }),
                Spell.Cast("blah", ret => false));
        }
    }
}