﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    public static class OperativeLethality
    {
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeLethality)]
        public static Composite OperativeLethalityPull()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.LethalityCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeLethality)]
        public static Composite OperativeLethalityCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.LethalityCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeLethality)]
        public static Composite OperativeLethalityOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }

    }
}