﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Buddy.Swtor.Objects;
using Buddy.Common.Math;
using System;
using Buddy.Common;

using Action = Buddy.BehaviorTree.Action;

using System.Collections.Generic;
using System.Diagnostics;
using System.ComponentModel;

namespace DefaultCombat.Routines
{

    public class AgentSniper
    {

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Agent, AdvancedClass.Sniper, SkillTreeId.SniperMarksmanship)]
        public static Composite MarksmanshipPull()
        {
            return new Sequence(
                new Action(ret => { MercHelpers.SniperMarksmanshipCombat(); }),
                Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Agent, AdvancedClass.Sniper, SkillTreeId.SniperMarksmanship)]
        public static Composite MarksmanshipCombat()
        {
            return new Sequence(
                new Action (ret => {MercHelpers.SniperMarksmanshipCombat();}),
                Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Agent, AdvancedClass.Sniper, SkillTreeId.SniperMarksmanship)]
        public static Composite AgentOutOfCombat()
        {
            return new Sequence(
                new Action(ret => { MercHelpers.OOC(); }),
                Spell.Cast("blah", ret => false)
                );
        }
    
    }
}