﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    public static class OperativeMedic
    {
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeMedic)]
        public static Composite OperativeMedicCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.MedicineCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeMedic)]
        public static Composite OperativeMedicPull()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.MedicineCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Agent, AdvancedClass.Operative, SkillTreeId.OperativeMedic)]
        public static Composite OperativeMedicOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }
    }
}