﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    public static class ScoundrelScrapper
    {
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.ScoundrelScrapper)]
        public static Composite ScoundrelScrapperPull()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.ScrapperCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.ScoundrelScrapper)]
        public static Composite ScoundrelScrapperCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.ScrapperCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.ScoundrelScrapper)]
        public static Composite ScoundrelScrapperOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }

    }
}