﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using Buddy.Swtor.Objects;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    //Neo93
    public static class SageSeer
    {
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageSeer)]
        public static Composite SageSeerPull()
        {
            return new Sequence(new Action(ret => { MercHelpers.SeerCombat(); }),
                Spell.Cast("blah", ret => false));
        }
        
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageSeer)]
        public static Composite SageSeerCombat()
        {
            return new Sequence(new Action(ret => { MercHelpers.SeerCombat(); }),
                Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageSeer)]
        public static Composite SageSeerOutOfCombat()
        {
            return new Sequence(new Action(ret => { MercHelpers.OOC(); }),
                Spell.Cast("blah", ret => false));
        }

        private static Composite PreCombat()
        {
            foreach (var p in Helpers.Group)
            {
                new PrioritySelector(
                    Spell.Cast("Force Armor", on => p, ret => !p.HasBuff("Force Armor") && !p.HasDebuff("Force-imbalance"))
                );
            }
            return SageSeerPull();
        }
    }
}