﻿using System;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using System.Linq;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines
{
    public class TrooperShieldSpecialist
    {
        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Trooper, AdvancedClass.Vanguard, SkillTreeId.VanguardShieldSpecialist)]
        public static Composite ShieldSpecialistPull()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.SSCombat(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Trooper, AdvancedClass.Vanguard, SkillTreeId.VanguardShieldSpecialist)]
        public static Composite ShieldSpecialistOutOfCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.OOC(); }), Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Trooper, AdvancedClass.Vanguard, SkillTreeId.VanguardShieldSpecialist)]
        public static Composite ShieldSpecialistCombat()
        {
            return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.SSCombat(); }), Spell.Cast("blah", ret => false));
        }
    }
}