﻿using System;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using System.Linq;
using DefaultCombat.Dynamics;

namespace DefaultCombat.Routines.Basic
{
    public class Trooper
    {
        [Class(CharacterClass.Trooper)]
        [Behavior(BehaviorType.Combat)]
        public static Composite TrooperCombat()
        {
            //return new Sequence(new Buddy.BehaviorTree.Action(ret => { MercHelpers.CombatMedicCombat(); }), Spell.Cast("blah", ret => false));
            //Neo93 29.04.2012
            return new PrioritySelector(
                Spell.WaitForCast(),
                Movement.StopInRange(2.8f),

                //***Generel***
                Spell.Cast("Tenacity", castWhen => BuddyTor.Me.IsStunned),//Insignia
                Spell.Cast("Recharge Cells", ret => BuddyTor.Me, ret => BuddyTor.Me.ResourceStat >= 60),//-60 Heat

                //**Offensive**
                //Spell.CastOnGround("Death from Above",castWhen => BuddyTor.Me.ResourceStat <= 23, BuddyTor.Me.CurrentTarget.Position),
                Spell.Cast("High Impact Bolt", castWhen => BuddyTor.Me.CurrentTarget.IsStunned),
                Spell.Cast("Sticky Grenade", castWhen => Helpers.Targets.Count() >= 2 && BuddyTor.Me.ResourceStat <= 23),
                Spell.Cast("Full Auto", castWhen => BuddyTor.Me.ResourceStat <= 63),//+16 Heat/15s CD
                Spell.Cast("Stockstrike", castWhen => BuddyTor.Me.ResourceStat <= 63),//Melee
                Spell.Cast("Explosive Round", castWhen => BuddyTor.Me.ResourceStat <= 63),//+25 Heat
                Spell.Cast("Pulse Cannon", castWhen => BuddyTor.Me.ResourceStat <= 63 && Helpers.Targets.Count(t => t.Distance <= 1) >= 3),
                Spell.Cast("Hammer Shot"),

                Movement.MoveTo(ret => BuddyTor.Me.CurrentTarget.Position, 2.8f)
                );
        }

        [Class(CharacterClass.Trooper)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite TrooperOutOfCombat()
        {
            return new PrioritySelector(
                Spell.BuffSelf("Plasma Cell")//Weapon Buff
                );
        }


        [Class(CharacterClass.Trooper)]
        [Behavior(BehaviorType.Pull)]
        public static Composite TrooperPull()
        {
            return TrooperCombat();
        }

    }
}