﻿using System;
using System.Linq;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;
using DefaultCombat.Dynamics;
using Action = Buddy.BehaviorTree.Action;

namespace DefaultCombat.Routines
{
    public static class SentinelWatchman
    {

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelWatchman)]
        public static Composite SentinelWatchmanPull()
        {
            return new Sequence(new Action(ret => { MercHelpers.WatchmanCombat(); }),
                Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelWatchman)]
        public static Composite SentinelWatchmanCombat()
        {
            return new Sequence(new Action(ret => { MercHelpers.WatchmanCombat(); }),
                Spell.Cast("blah", ret => false));
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelWatchman)]
        public static Composite SentinelWatchmanOutOfCombat()
        {
            return new Sequence( 
            new Action(ret => { MercHelpers.OOC(); }),
               Spell.Cast("blah", ret => false)
                );
        }
    }
}
